'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var core = require('@material-ui/core');
var CloseIcon = _interopDefault(require('@material-ui/icons/Close'));
var PropTypes = _interopDefault(require('prop-types'));
var Button = _interopDefault(require('@material-ui/core/Button'));
var styles$1 = require('@material-ui/core/styles');
var kendoReactInputs = require('@progress/kendo-react-inputs');
var _ = _interopDefault(require('lodash'));
var kendoDataQuery = require('@progress/kendo-data-query');
var kendoReactDropdowns = require('@progress/kendo-react-dropdowns');
var kendoReactDateinputs = require('@progress/kendo-react-dateinputs');
var moment = _interopDefault(require('moment'));
var kendoIntl = require('@telerik/kendo-intl');
var Grid = _interopDefault(require('@material-ui/core/Grid'));

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
}

var StyleCheckbox = core.withStyles({
    root: {
        padding: '3px',
    }
})(core.Checkbox);
var FeeCheckbox = /** @class */ (function (_super) {
    __extends(FeeCheckbox, _super);
    function FeeCheckbox() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: null,
            checked: false,
        };
        _this.getChecked = function (value) {
            switch (value) {
                case _this.props.trueStr:
                    return true;
                case _this.props.falseStr:
                    return false;
                default:
                    return _this.props.defaultChecked || false;
            }
        };
        _this.getValue = function (checked) { return (checked ? _this.props.trueStr : _this.props.falseStr); };
        // the callback of material ui check.onChange
        _this.handleChange = function (event, checked) {
            var newValue = {
                code: _this.getValue(event.target.checked),
                show: event.target.checked,
                checked: event.target.checked
            };
            _this.props.onChange && _this.props.onChange(event, newValue);
            _this.setState({
                value: _this.getValue(event.target.checked),
                checked: event.target.checked
            });
        };
        return _this;
    }
    FeeCheckbox.prototype.componentDidMount = function () {
        this.setState({
            value: this.props.defaultValue,
            checked: this.getChecked(this.props.defaultValue)
        });
    };
    FeeCheckbox.prototype.render = function () {
        var _a = this.props, trueStr = _a.trueStr, falseStr = _a.falseStr, defaultValue = _a.defaultValue, defaultChecked = _a.defaultChecked, placeholder = _a.placeholder, restProps = __rest(_a, ["trueStr", "falseStr", "defaultValue", "defaultChecked", "placeholder"]);
        return (React__default.createElement("div", { style: { paddingLeft: '7px' } },
            React__default.createElement(core.FormControlLabel, { control: React__default.createElement(StyleCheckbox, __assign({}, restProps, { disabled: this.props.disabled, checked: this.state.checked, onChange: this.handleChange })), label: this.props.placeholder })));
    };
    FeeCheckbox.defaultProps = {
        defaultChecked: false,
        trueStr: '是',
        falseStr: '否'
    };
    return FeeCheckbox;
}(React__default.PureComponent));

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

const Style = {
  "title": {
    "padding": "0px 24px 0px 12px",
    "fontSize": "1.2rem",
    "color": "rgb(181, 41, 18)",
    "borderLeft": "3px #b52912 solid",
    "marginBottom": "10px",
    "marginTop": "10px",
    "fontWeight": "bold"
  },
  "popuptitle": {
    "fontSize": "1.2rem",
    "background": "-webkit-linear-gradient(top, #f4ece1, #ddd1bb)",
    "backgroundColor": "#f4ece1",
    "borderBottomColor": "#ddd1bb",
    "width": "100%",
    "padding": "10px",
    "fontWeight": "bold"
  }
};
const Title = props => {
  return React__default.createElement("div", {
    className: Style.title
  }, props.title);
};
const PopupTitle = props => {
  return React__default.createElement("div", {
    className: Style.popuptitle
  }, props.title);
};

// react
const Style$1 = {
  "function_button_area": {
    "width": "100%",
    "marginTop": "12px",
    "display": "inline-flex",
    "justifyContent": "center"
  },
  "listitem": {
    "display": "inline-flex",
    "width": "100%",
    "alignItems": "center",
    "justifyContent": "flex-start"
  },
  "popup_content": {
    "padding": "24px"
  },
  "text": {
    "fontWeight": "300"
  }
};
const StyledPopover = core.withStyles({
  paper: {
    width: "300px",
    maxWidth: "none"
  }
})(core.Popover);
const StyledConfirmButton = core.withStyles({
  root: {
    fontSize: "14px",
    width: "64px",
    background: "-webkit-linear-gradient(top, #f4ece1, #ddd1bb)",
    border: "1px solid #ddd1bb",
    "&:hover": {
      border: "1px solid #b52912",
      background: "#b52912",
      color: "#ddd1bb"
    }
  }
})(core.Button);
const StyledCancelButton = core.withStyles({
  root: {
    fontSize: "14px",
    width: "64px",
    backgroundColor: "#fff",
    color: "#444",
    border: "1px solid transparent",
    borderColor: "#ccc",
    borderRadius: "3px",
    "&:hover": {
      border: "1px solid gray",
      background: "white"
    }
  }
})(core.Button);

const PopupEditTitle = props => {
  return React__default.createElement("div", {
    className: Style$1.listitem
  }, React__default.createElement(PopupTitle, {
    title: "\u63D0\u793A\u8A0A\u606F"
  }), React__default.createElement(core.IconButton, {
    style: {
      position: "absolute",
      right: "12px",
      top: "0px"
    },
    onClick: props.handleOpenChange
  }, React__default.createElement(CloseIcon, null)));
};
/*
    Usage: Get State from Redux
    Store:
    Process:
*/


const DeleteConfirm = props => {
  return React__default.createElement(StyledPopover, {
    open: true,
    style: {
      zIndex: 100,
      background: "rgba(0, 0, 0, 0.4)"
    },
    anchorOrigin: {
      vertical: "bottom",
      horizontal: "center"
    },
    transformOrigin: {
      vertical: "center",
      horizontal: "center"
    }
  }, React__default.createElement(PopupEditTitle, {
    handleOpenChange: props.handleOpenChange
  }), React__default.createElement("div", {
    className: Style$1.popup_content
  }, React__default.createElement("p", {
    className: Style$1.text
  }, "\u662F\u5426\u78BA\u8A8D\u522A\u9664"), React__default.createElement("div", {
    className: Style$1.function_button_area
  }, React__default.createElement(StyledConfirmButton, {
    onClick: props.handleConfirmClick
  }, "\u78BA\u8A8D"), React__default.createElement("div", {
    style: {
      width: "15px"
    }
  }), React__default.createElement(StyledCancelButton, {
    onClick: props.handleOpenChange
  }, "\u53D6\u6D88"))));
};

class FeeDeleteConfirm extends React__default.PureComponent {
  render() {
    const {
      open,
      handleOpenChange,
      handleConfirmClick,
      ...restProps
    } = this.props;

    if (open) {
      return React__default.createElement(DeleteConfirm, _extends({}, restProps, {
        handleOpenChange: handleOpenChange,
        handleConfirmClick: handleConfirmClick
      }));
    } else return '';
  }

}

const StyledButtonConfirm = core.withStyles({
  root: {
    fontSize: '0.875rem',
    fontFamily: "MSBlack, Microsoft JhengHei, 微軟正黑體",
    borderRadius: '0px',
    width: '64px',
    background: '-webkit-linear-gradient(top, #f4ece1, #ddd1bb)',
    border: '1px solid #ddd1bb',
    '&:hover': {
      border: '1px solid #b52912',
      background: '#b52912',
      color: '#ddd1bb'
    }
  }
})(Button);
const StyledButtonCancel = core.withStyles({
  root: {
    borderRadius: '0px',
    fontSize: '0.875rem',
    fontFamily: "MSBlack, Microsoft JhengHei, 微軟正黑體",
    width: '64px',
    backgroundColor: '#fff',
    color: '#444',
    border: '1px solid transparent',
    borderColor: '#ccc',
    '&:hover': {
      border: '1px solid gray',
      background: 'white'
    }
  }
})(Button);
const StyledAreaFuctionButton = core.withStyles({
  root: {
    borderRadius: '0px',
    border: '1px solid #ddd1bb',
    fontSize: '0.875rem',
    fontFamily: "MSBlack, Microsoft JhengHei, 微軟正黑體",
    '&:hover': {
      background: '#e6e6e6'
    }
  }
})(Button);
class StyledButton extends React__default.Component {}

const popupStyles = () => ({
  listitem: {
    display: 'inline-flex',
    width: '100%',
    alignItems: 'center',
    justifyContent: 'flex-start'
  },
  popup_title: {
    backgroundColor: '#f4ece1',
    background: '-webkit-linear-gradient(top, #f4ece1, #ddd1bb)',
    borderBottomColor: '#ddd1bb',
    paddingTop: '7px',
    paddingBottom: '7px'
  },
  popup_title_font: {
    fontWeight: '900',
    fontSize: '30px'
  },
  popup_functionarea: {
    width: '100%',
    display: 'inline-flex',
    justifyContent: 'center'
  },
  close_icon: {
    position: 'absolute',
    right: '12px',
    top: '6px'
  }
});

const StyledDialog = core.withStyles({
  root: {
    background: 'rgba(0, 0, 0, 0.4)'
  },
  paper: {
    width: '70%',
    maxWidth: 'none',
    borderRadius: '5px'
  }
})(core.Dialog);

class FeeDialog extends React__default.PureComponent {
  constructor(...args) {
    super(...args);
    this.state = {
      value: null
    };
  }

  render() {
    const {
      classes
    } = this.props; // 在 style 設定 zIndex , 讓 ComboBox 可在 Dialog 上面顯示

    /*
      disableEnforceFocus : 讓 kendo-ui datePicker 不會自動關起來
    參考資料 : https://www.telerik.com/forums/datepicker-closes-directly-when-used-in-material-ui-dialog#74FkZxAElEKx6vn6au285g
       */

    return React__default.createElement(StyledDialog, {
      disableEnforceFocus: true,
      open: true,
      style: {
        zIndex: 50
      }
    }, React__default.createElement(core.DialogTitle, {
      className: classes.popup_title
    }, React__default.createElement("span", {
      className: classes.popup_title_font
    }, this.props.title), React__default.createElement(core.IconButton, {
      className: classes.close_icon,
      onClick: this.props.handleClose
    }, React__default.createElement(CloseIcon, null))), React__default.createElement(core.DialogContent, {
      dividers: true
    }, this.props.content), React__default.createElement(core.DialogActions, null, React__default.createElement("div", {
      className: classes.popup_functionarea
    }, this.props.buttons.map(button => {
      return React__default.createElement(StyledButtonCancel, {
        key: button.name,
        onClick: button.onClick
      }, button.name);
    }))));
  }

}

FeeDialog.propTypes = {
  handleClose: PropTypes.func.isRequired,
  title: PropTypes.string.isRequired,
  buttons: PropTypes.array,
  filter: PropTypes.object // 將 filter 資訊放入其中

};
FeeDialog.defaultProps = {
  buttons: []
};
var FeeDialog$1 = core.withStyles(popupStyles)(FeeDialog);

// react
const style = {
  wordWrap: {
    wordWrap: 'break-word',
    marginTop: '5px',
    marginBottom: '5px'
  },
  commentFont: {
    wordWrap: 'break-word',
    color: '#0202ff'
  }
}; // WordWrapP 可能需要改成 String 顯示的原件 , 分不同類型 ( 一般 . 代碼轉中文 . 文字轉日期 . 文字轉金額 )

const WordWrapP = props => React__default.createElement("p", {
  style: { ...style.wordWrap,
    ...props.style
  }
}, props.children || '');

const CommentFont = props => React__default.createElement("div", {
  style: style.commentFont
}, props.children || '');

const getOptionObj = (options, code, defaultShow) => {
  return options.find(option => option.code === code) || {
    code,
    show: defaultShow
  };
};

const leftStr = (str, num) => str.substring(0, num);

const rightStr = (str, num) => str.substring(str.length - num, str.length);

const getCodeFieldName = ObjFieldName => ObjFieldName.substring(0, ObjFieldName.length - 3);

const getDataOriginPK = (propSingleData = {}) => {
  const newProps = Object.keys(propSingleData).reduce((previous, key) => {
    // 將帶有 former 開頭的 key , value 代到新的 object 中
    if (leftStr(key, 6) !== 'former') return previous;else {
      return { ...previous,
        [key]: propSingleData[key]
      };
    }
  }, {});
  return newProps;
};

const objIsEmpty = obj => {
  // for ... in , 參考資料 : https://developer.mozilla.org/zh-TW/docs/Web/JavaScript/Reference/Statements/for...in
  for (let prop in obj) {
    if (Boolean(obj[prop])) return false;
  }

  return true;
};

const objNotEmpty = obj => !objIsEmpty(obj); // 捲動到目標位置 , 會多往上捲動 :headerOffset 距離


const smoothScrollTo = elementId => {
  setTimeout(() => {
    try {
      const element = document.getElementById(elementId);
      const headerOffset = 45;
      const elementPosition = element.getBoundingClientRect().top + window.scrollY;
      const offsetPosition = elementPosition - headerOffset;
      window.scrollTo({
        top: offsetPosition,
        behavior: "smooth"
      });
    } catch (e) {
      if (process.env.REACT_APP_DEBUG_MODE === "ON") {
        // .env.development 中 DEBUG_MODE 開啟時
        console.error(`when elementId = ${elementId}`, `smoothScrollTo has error=`, e);
      }
    }
  }, 200);
};

const getMessages = (fieldName, {
  warnMessages,
  errMessages,
  validateMessages
}) => {
  return {
    warnMessage: warnMessages && warnMessages[fieldName],
    errMessage: errMessages && errMessages[fieldName],
    validateMessage: validateMessages && validateMessages[fieldName]
  };
};

const getValidationMessage = (fieldName, errMessages) => {
  const errMsg = errMessages && errMessages[fieldName];
  return {
    valid: !errMsg,
    validationMessage: errMsg
  };
}; // 取得 from ~ to 的數字陣列


const getNumberArray = (from, to) => {
  let result = [];

  for (let i = from; i <= to; i++) {
    result.push(i);
  }

  return result;
}; // 中文：/^[\u4E00-\u9FA5]+$/


const isChineseChar = char => 0x4E00 <= char && char <= 0x9FA5;

const getByteCount = str => {
  return [...str].reduce((pre, curr) => isChineseChar(curr) ? pre + 3 : pre + 1, 0);
};

const debounceMap = {}; // Define the method directly in your class
// 產生延遲一秒效果的 function
// 參考資料 : https://stackoverflow.com/questions/36294134/lodash-debounce-with-react-input

const getDebounceFunc = (taskId, fieldName, wait = 1000) => {
  const tempFunc = debounceMap[`${taskId}-${fieldName}`];

  if (tempFunc) {
    return tempFunc;
  } else {
    const newTempFunc = _.debounce(func => func(), wait);

    debounceMap[`${taskId}-${fieldName}`] = newTempFunc;
    return newTempFunc;
  }
};

const retrieveFormErrMsg = err => {
  const formErrMsg = err.msg ? err.msg : '無法連接到伺服器 , 請稍後再試 !';
  return formErrMsg;
};

const initMessages = ({
  data,
  messageChecker
}) => {
  const keys = Object.keys(data);
  const warnMessages = {};

  for (let i = 0; i < keys.length; i++) {
    const key = keys[i];
    const warnDataObj = messageChecker && messageChecker({
      singleData: data,
      fieldName: key,
      value: data[key]
    });
    warnMessages[key] = warnDataObj && warnDataObj[key];
  }

  return warnMessages;
};

const getWarnDataMsg = ({
  fieldName,
  value,
  maxLength,
  chFieldName
}) => {
  return value && value.length >= maxLength ? {
    [fieldName]: `提示 : ${chFieldName}至多可輸入${maxLength}個字`
  } : {
    [fieldName]: undefined
  };
};

const baseGetNewData = ({
  fieldName,
  value
}) => {
  if (typeof fieldName === "object") {
    const {
      from,
      to
    } = fieldName;
    const {
      fromValue,
      toValue
    } = value;
    return {
      [`${from}Obj`]: fromValue,
      [from]: fromValue.code,
      [`${to}Obj`]: toValue,
      [to]: toValue.code
    };
  } else if (rightStr(fieldName, 3) === 'Obj') {
    const codeFieldName = getCodeFieldName(fieldName);
    return {
      [codeFieldName]: value && value.code,
      [fieldName]: value
    };
  } else if (rightStr(fieldName, 4).toLowerCase() === 'date') {
    return {
      [`${fieldName}Obj`]: value,
      [fieldName]: value && value.code
    };
  } else {
    return {
      [fieldName]: value
    };
  }
};

// boxShadow 參考資料 : https://css-tricks.com/snippets/css/glowing-blue-input-highlights/
var inputStyles = function () { return ({
    input: {
        width: '90%'
    },
    error: {
        border: '1px solid red',
        '&:focus': {
            border: '1px solid red',
            boxShadow: '0 0 5px red'
        },
        '&:hover': {
            border: '1px solid red',
            boxShadow: '0 0 5px red'
        }
    },
}); };
var FeeInput = /** @class */ (function (_super) {
    __extends(FeeInput, _super);
    function FeeInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: undefined,
        };
        _this.getClassName = function (_a) {
            var feeValidate = _a.feeValidate, classes = _a.classes;
            return (feeValidate === false) ? classes.input + " " + classes.error : classes.input;
        };
        _this.maxLengthChecker = function (_a) {
            /*
    
            JS 判斷中文字 ( 中文長度 * 3 , 其他長度 * 1 )
    
            https://dotblogs.com.tw/greens/archive/2010/11/25/19710.aspx
    
            https://blog.csdn.net/qq_35661171/article/details/78967827
    
            https://blog.csdn.net/yenange/article/details/7463897
    
            */
            var value = _a.value, maxLength = _a.maxLength;
            return (value && maxLength && getByteCount(value.toString()) > maxLength);
        };
        _this.handleChange = function (event) {
            var _a = _this.props, maxLength = _a.maxLength, maskType = _a.maskType, min = _a.min, max = _a.max;
            var value = event.target.value;
            if (maskType !== 'number' && _this.maxLengthChecker({ value: value, maxLength: maxLength })) {
                return;
            }
            else {
                _this.props.onChange && _this.props.onChange(event, value);
                _this.setState({ value: value });
            }
        };
        return _this;
    }
    FeeInput.prototype.componentWillMount = function () {
        this.setState({ value: this.props.defaultValue });
    };
    FeeInput.prototype.render = function () {
        var _a = this.props, maskType = _a.maskType, feeValidate = _a.feeValidate, classes = _a.classes, defaultValue = _a.defaultValue, restProps = __rest(_a, ["maskType", "feeValidate", "classes", "defaultValue"]);
        if (this.props.maskType === 'number') {
            // format 參考資料 : https://www.telerik.com/kendo-react-ui/components/inputs/numerictextbox/formats/
            return (React.createElement(kendoReactInputs.NumericTextBox, __assign({ className: this.getClassName({ feeValidate: feeValidate, classes: classes }) }, restProps, { value: (typeof this.state.value === "number") ? this.state.value : 0, onChange: this.handleChange })));
        }
        else if (this.props.maskType === 'text' || this.props.maskType === 'string') {
            // mask 參考資料 : https://www.telerik.com/kendo-react-ui/components/inputs/maskedtextbox/masks/
            // maskValidation={false} 關閉 mask 紅框
            return (React.createElement(kendoReactInputs.MaskedTextBox, __assign({ className: this.getClassName({ feeValidate: feeValidate, classes: classes }) }, restProps, { value: (typeof this.state.value === "string") ? this.state.value : '', onChange: this.handleChange })));
        }
        else {
            return (React.createElement(kendoReactInputs.Input, __assign({ type: 'text', className: this.getClassName({ feeValidate: feeValidate, classes: classes }) }, restProps, { value: (typeof this.state.value === "string") ? this.state.value : '', onChange: this.handleChange })));
        }
    };
    return FeeInput;
}(React.PureComponent));
var FeeInput$1 = styles$1.withStyles(inputStyles)(FeeInput);

const StyleRadio = core.withStyles({
  root: {
    padding: '3px'
  }
})(core.Radio);
/*
    Usage: Render FeeRadioGroup
    Props:
        defaultValue: 預設值,
        data: 單選按鈕所有選項,
        onChange: 選單按鈕改變的處理函式,
        disabled: 單選按鈕是否禁用,
    state:
        value: 目前數值,
*/

class FeeRadioGroup extends React.Component {
  constructor(...args) {
    super(...args);
    this.state = {
      value: null
    };

    this.handleChange = (event, value) => {
      // disabled 時 , 將 radio button 上鎖 , 不做 handleChange
      if (this.props.disabled) return; // 取得 value 物件

      const tempValue = this.props.data.find(obj => (obj.value || obj.code) === event.target.value); // 將 newValue 組成 { code , show } 物件

      const newValue = {
        code: tempValue.value,
        show: tempValue.label,
        ...tempValue
      };
      this.props.onChange && this.props.onChange(event, newValue);
      this.setState({
        value
      });
    };
  }

  componentWillMount() {
    this.setState({
      value: this.props.defaultValue
    });
  }

  render() {
    return React.createElement("div", {
      style: {
        paddingLeft: '7px'
      }
    }, React.createElement(core.RadioGroup, _extends({}, this.props, {
      defaultValue: this.props.defaultValue,
      value: this.state.value,
      style: {
        display: 'inline'
      },
      onChange: this.handleChange
    }), this.props.data.map((element, index) => element && React.createElement(core.FormControlLabel, {
      key: 'radio-' + index,
      disabled: this.props.disabled,
      value: element.value || element.code,
      label: element.label || element.show,
      onKeyDown: this.props.onKeyDown,
      control: React.createElement(StyleRadio, null)
    }))));
  }

}

FeeRadioGroup.propTypes = {
  defaultValue: PropTypes.string.isRequired,
  data: PropTypes.array.isRequired,
  onChange: PropTypes.func,
  disabled: PropTypes.bool
};
FeeRadioGroup.defaultProps = {
  disabled: false
};

/*
    Author: andrew
    Date: 2019/07/15
    Usage: Render FeeTabBar
*/

const tabStyles = () => ({
  tabcontainer: {
    padding: '12px 12px 12px 12px'
  },
  tab: {
    fontSize: '20px',
    fontWeight: 'bold'
  }
});
/*
    Usage: Render FeeTabBar
    Props:
        defaultTabValue: 預設顯示的頁籤,
        data: 頁籤相關資料,
        onChange: 切換頁籤時的處理函式,
        disabled: 頁籤選擇是否禁用,
    state:
        tabValue: 目前頁籤參數值
*/


class FeeTabBar extends React__default.PureComponent {
  constructor(...args) {
    super(...args);
    this.state = {
      tabValue: 0
    };

    this.handleTabValueChange = (event, newValue) => this.setState({
      tabValue: newValue
    });

    this.renderTabTitle = data => {
      const {
        classes
      } = this.props;
      return data.map((element, index) => React__default.createElement(core.Tab, {
        key: index,
        className: classes.tab,
        label: element.label
      }));
    };

    this.renderTabContent = data => {
      const {
        tabValue
      } = this.state;
      const {
        classes
      } = this.props;
      return data.map((element, index) => tabValue === index && React__default.createElement(core.Paper, {
        key: index,
        square: true,
        className: classes.tabcontainer
      }, element.control));
    };
  }

  render() {
    const {
      tabValue
    } = this.state;
    return React__default.createElement("div", null, React__default.createElement(core.AppBar, {
      position: "static",
      color: "default"
    }, React__default.createElement(core.Tabs, {
      value: tabValue,
      onChange: this.handleTabValueChange,
      indicatorColor: "primary",
      textColor: "primary"
    }, this.renderTabTitle(this.props.data))), this.renderTabContent(this.props.data));
  }

}

FeeTabBar.propTypes = {
  data: PropTypes.array.isRequired
};
var FeeTab = core.withStyles(tabStyles)(FeeTabBar);

// react
const StyledToolbarButton = core.withStyles({
  root: {
    borderRadius: '0px',
    background: '-webkit-linear-gradient(top, #f4ece1, #ddd1bb)',
    border: '1px solid #ddd1bb',
    fontFamily: "Helvetica, Arial, '微軟正黑體', sans-serif",
    '&:hover': {
      border: '1px solid #b52912',
      background: '#b52912',
      color: '#ddd1bb'
    }
  }
})(core.Button);

const taskBarStyles = () => ({
  taskbar: {
    padding: '10px',
    border: '1px solid #dfdfdf',
    backgroundColor: '#fff'
  },
  taskbar_fixed: {
    width: '100%',
    padding: '10px',
    border: '1px solid #dfdfdf',
    backgroundColor: '#fff',
    position: 'fixed',
    top: 0,
    zIndex: 30
  },
  marginbottom_12: {
    marginBottom: '12px'
  }
});
/* props {
        scrolledHeight 是否置頂的判斷變數
        buttons {
            name: 按鈕名稱 & 顯示文字
            onClick: onClick event handler
        }
    }
*/


class FeeTaskBar extends React.Component {
  // 必須要加此段 , 不然會報錯 , 參考資料 : https://gist.github.com/koistya/934a4e452b61017ad611#gistcomment-2194590
  constructor(props) {
    super(props);
    this.state = {
      scrolledHeight: 0,
      changeHeight: 160
    };

    this.getTaskBarClassName = (scrolledHeight, changeHeight, noFixed) => {
      const {
        classes
      } = this.props;
      if (noFixed) return classes.marginbottom_12 + " " + classes.taskbar + " " + this.props.className;else if (scrolledHeight > changeHeight) return classes.taskbar_fixed;else return classes.marginbottom_12 + " " + classes.taskbar + " " + this.props.className;
    };

    this.getBlockHeight = (scrolledHeight, changeHeight) => {
      const feeTaskBarElement = document.getElementById('feeTaskBar');
      const feeTaskBarHeight = feeTaskBarElement && feeTaskBarElement.clientHeight || 0;
      if (scrolledHeight < changeHeight) return 0;else return feeTaskBarHeight;
    };

    this.handleWindowOnScroll = this.handleWindowOnScroll.bind(this);
  }
  /*
  Usage: 監聽視窗捲動事件
  Param: none
  As Callback: none
  */


  componentDidMount() {
    window.addEventListener('scroll', this.handleWindowOnScroll);
  }

  /*
  Usage: 移除視窗捲動事件
  Param: none
  As Callback: none
  */
  componentWillUnmount() {
    window.removeEventListener('scroll', this.handleWindowOnScroll);
    window.onscroll = undefined;
  }

  /*
  Usage: 抓取頁面捲動高度，判斷是否要置頂
  Param: none
  As Callback: none
  */
  handleWindowOnScroll() {
    window.onscroll = () => {
      const h = window.pageYOffset;
      const {
        scrolledHeight,
        changeHeight
      } = this.state;

      if (scrolledHeight < changeHeight && h > changeHeight) {
        this.setState({
          scrolledHeight: h
        });
      }

      if (scrolledHeight > changeHeight && h < changeHeight) {
        this.setState({
          scrolledHeight: h
        });
      }
    };
  }

  render() {
    const {
      scrolledHeight,
      changeHeight
    } = this.state;
    const hasFixed = !this.props.noFixed; // 卡一個塊空白 div , 以免在某些情況下會出現下拉問題

    return React.createElement(React.Fragment, null, hasFixed && React.createElement("div", {
      style: {
        height: this.getBlockHeight(scrolledHeight, changeHeight) + 'px'
      }
    }), React.createElement("div", {
      id: "feeTaskBar",
      style: this.props.style,
      className: this.getTaskBarClassName(scrolledHeight, changeHeight, this.props.noFixed)
    }, this.props.buttons.map((button, index) => {
      // 先確認 button 是 ReactElement 還是 ReactProps
      if (React.isValidElement(button)) return React.cloneElement(button, {
        key: button.name + '-' + index
      });else return React.createElement(StyledToolbarButton, {
        key: button.name + '-' + index,
        onClick: button.onClick,
        disabled: button.buttonStatus === "R",
        style: button.buttonStatus === "N" ? {
          display: "none"
        } : {}
      }, button.name);
    })));
  }

}

FeeTaskBar.propTypes = {
  buttons: PropTypes.array,
  noFixed: PropTypes.bool
};
FeeTaskBar.defaultProps = {
  style: {},
  className: '',
  buttons: [],
  buttonStatus: "",
  noFixed: false
};
var FeeTaskbar = core.withStyles(taskBarStyles)(FeeTaskBar);

var Style$2 = {
    combobox: {
        width: '90%',
        color: '#212529',
    }
};
var FilterableComboBox = /** @class */ (function (_super) {
    __extends(FilterableComboBox, _super);
    function FilterableComboBox() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            data: __spreadArrays(_this.props.data),
            filter: null,
            value: null,
        };
        _this.handleChange = function (event) {
            // 取得 value 物件
            var tempValue = event.target.value;
            // 將 newValue 組成 { code , show } 物件
            var newValue = tempValue && __assign({ code: tempValue.dataItemKey, show: tempValue.textField }, tempValue);
            _this.props.onChange && _this.props.onChange(event, newValue);
            _this.setState({
                value: event.target.value
            });
        };
        _this.filterChange = function (event) {
            _this.setState({
                data: _this.filterData(event.filter),
                filter: event.filter,
                value: Boolean(event.filter.value) ? _this.state.value : undefined
            });
        };
        _this._getNewClearButton = function (_a) {
            var clearButton = _a.clearButton, required = _a.required;
            if (required || clearButton === false) {
                return false;
            }
            return true;
        };
        return _this;
    }
    FilterableComboBox.prototype.componentWillMount = function () {
        // dataItemKey 沒值時 , 設定 dataItemKey = code
        var _a = this.props, _b = _a.dataItemKey, _c = _a.textField;
        // const commonDefaultValue = {[dataItemKey]: undefined, [textField]: '請選擇'};
        var newDefaultValue = this.props.defaultValue; // || commonDefaultValue;
        this.setState({ filter: newDefaultValue, value: newDefaultValue });
    };
    FilterableComboBox.prototype.filterData = function (filter) {
        var data = __spreadArrays(this.props.data);
        return kendoDataQuery.filterBy(data, filter);
    };
    FilterableComboBox.prototype.render = function () {
        // 如果 this.props 有 dataItemKey 會把現有的蓋掉
        return (React.createElement(kendoReactDropdowns.ComboBox, __assign({ textField: "show", dataItemKey: "code", placeholder: '\u8ACB\u9078\u64C7' }, this.props, { style: __assign(__assign({}, Style$2.combobox), this.props.style), clearButton: this._getNewClearButton(this.props), value: this.state.value, data: (this.state.filter) ? this.state.data : this.props.data, filterable: true, onFilterChange: this.filterChange, onChange: this.handleChange })));
    };
    FilterableComboBox.propTypes = {
        data: PropTypes.array,
        defaultValue: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
    };
    return FilterableComboBox;
}(React.PureComponent));

// react
const Style$3 = {
  alert_message: {
    color: 'white',
    backgroundColor: '#dd4b39',
    width: '100%',
    paddingTop: '12px',
    paddingBottom: '12px',
    marginBottom: '12px',
    borderColor: '#d73925',
    border: '1px solid transparent',
    borderRadius: '3px',
    textAlign: 'center'
  }
};
const AlertBlock = props => {
  return React__default.createElement("div", {
    className: Style$3.alert_message
  }, props.alertMessage);
};

const styles = theme => ({
  alert_message: {
    color: 'white',
    backgroundColor: '#dd4b39',
    width: '100%',
    paddingTop: '12px',
    paddingBottom: '12px',
    marginBottom: '12px',
    borderColor: '#d73925',
    border: '1px solid transparent',
    borderRadius: '3px',
    textAlign: 'left'
  }
});

class FeeAlertBlock extends React.Component {
  constructor(...args) {
    super(...args);

    this.getAlertMessage = alertMessages => {
      let result = [];

      if (typeof alertMessages === 'object') {
        for (let prop in alertMessages) {
          if (Boolean(alertMessages[prop])) {
            // 如果有值 , 將其放入顯示文字中
            result.push({
              fieldName: prop,
              value: alertMessages[prop]
            });
          }
        }
      }

      return result;
    };
  }

  render() {
    const {
      classes,
      alertOpen,
      alertMessages,
      fieldMapper,
      ...restProps
    } = this.props;
    return alertOpen ? React.createElement("div", {
      className: classes.alert_message
    }, React.createElement("ul", null, this.getAlertMessage(alertMessages).map((item, index) => {
      const fieldChName = fieldMapper && fieldMapper[item.fieldName];
      return React.createElement("li", {
        key: 'li-' + index
      }, `${fieldChName || item.fieldName}：${item.value}`);
    }))) : '';
  }

}

var FeeAlertBlock$1 = core.withStyles(styles)(FeeAlertBlock);

// react

class FormAlertBlock extends React.PureComponent {
  constructor(...args) {
    super(...args);

    this.getAlertMessage = alertMessage => {
      if (!alertMessage) {
        return '操作失敗提示訊息';
      } else if (typeof alertMessage === 'object') {
        if (!alertMessage.response) {
          return '無法連接到伺服器 , 請稍後再試 ! ';
        }

        return alertMessage.msg;
      } else if (typeof alertMessage === 'string') {
        return alertMessage;
      }
    };
  }

  render() {
    const {
      fieldMapper,
      alertMessage,
      alertOpen
    } = this.props;

    if (typeof this.props.alertMessage === 'object') {
      const newAlertOpen = alertOpen || objNotEmpty(alertMessage);
      return React.createElement(FeeAlertBlock$1, {
        alertOpen: newAlertOpen,
        fieldMapper: fieldMapper,
        alertMessages: alertMessage
      });
    } else {
      const newAlertOpen = alertOpen || Boolean(alertMessage);
      return newAlertOpen ? React.createElement(AlertBlock, {
        alertMessage: this.getAlertMessage(this.props.alertMessage)
      }) : '';
    }
  }

}

const numberUtil = {
  getFormatNumber({
    number,
    format = undefined
  }) {
    if (format === 'decimal') {
      return number && kendoIntl.formatNumber(number, {
        style: 'decimal'
      });
    }

    return number && kendoIntl.formatNumber(number, format || {
      style: 'decimal'
    });
  },

  getNumberObj({
    number,
    format = undefined
  }) {
    return number && {
      origin: number,
      price: kendoIntl.formatNumber(number, format || {
        style: 'decimal'
      })
    };
  }

};

const dateUtil = {
  addDays({
    date,
    format,
    days
  }) {
    return moment(date, format).add(days, "d");
  },

  getDateObj({
    date,
    format = undefined
  }) {
    // HHmm 的時間 , 需要補 0 做處理
    const newDate = format === 'HHmm' ? numberUtil.getFormatNumber({
      number: date,
      format: '0000'
    }) : date;
    return newDate && {
      dateStr: moment(newDate, format).format('YYYY/MM/DD'),
      dateTimeStr: moment(newDate, format).format('YYYY/MM/DD HH:mm:SS'),
      timeStr: moment(newDate, format).format('HH:mm:SS'),
      code: moment(newDate, format).format('YYYYMMDD'),
      show: moment(newDate, format).format('YYYY/MM/DD'),
      origin: newDate,
      date: moment(newDate, format).toDate()
    };
  },

  getDate({
    date,
    format = undefined
  }) {
    // HHmm 的時間 , 需要補 0 做處理
    const newDate = format === 'HHmm' ? numberUtil.getFormatNumber({
      number: date,
      format: '0000'
    }) : date;
    return newDate && moment(newDate, format).toDate();
  },

  getDateStr({
    date,
    format = undefined
  }) {
    return date && moment(date).format(format);
  },

  getSunday({
    date,
    format = undefined
  }) {
    return moment(date, format).startOf('week').toDate();
  },

  getSaturday({
    date,
    format = undefined
  }) {
    return moment(date, format).endOf('week').toDate();
  },

  getDayOfMonth({
    date,
    format = undefined
  }) {
    // Gets or sets the day of the month.
    return moment(date, format).date();
  },

  getFirstDayInMonth({
    date,
    format = undefined
  }) {
    return moment(date, format).startOf('month').toDate();
  },

  getLastDayInMonth({
    date,
    format = undefined
  }) {
    return moment(date, format).endOf('month').toDate();
  },

  getDaysInMonth({
    date,
    format = undefined
  }) {
    return moment(date, format).daysInMonth();
  },

  getNextMonth(date) {
    return moment(date).add(1, 'month').toDate();
  },

  getLastMonth(date) {
    return moment(date).add(-1, 'month').toDate();
  },

  getMonthArray({
    year,
    month
  }) {
    const monthFirstDate = new Date(year, month, 1);
    const monthLastDate = moment(monthFirstDate).endOf('month');
    const dayAmountOfThisMonth = monthLastDate.diff(monthFirstDate, 'days');
    const weekAmountOfThisMonth = Math.ceil(dayAmountOfThisMonth / 7);
    let currentDate = monthFirstDate;
    const monthArray = [];

    for (let i = 0; i < weekAmountOfThisMonth; i++) {
      const weekArray = this.getWeekArray(currentDate);
      monthArray.push(weekArray);
      currentDate = this.addSevenDay(currentDate);
    }

    return monthArray;
  },

  getMonthArrayWithDate(date) {
    return this.getMonthArray({
      year: moment(date).year(),
      month: moment(date).month()
    });
  },

  getWeekArray(date) {
    const from_date = moment(date).startOf('week').toDate();
    const to_date = moment(date).endOf('week').toDate();
    return this.getWeeklyDateArray({
      startDate: from_date,
      endDate: to_date
    });
  },

  getWeekDay(date) {
    return moment(date).weekday(); // Number
  },

  getWeeklyDateArray({
    startDate,
    endDate
  }) {
    const dateArray = [];
    let currentDate = startDate;

    while (currentDate <= endDate) {
      dateArray.push(currentDate);
      currentDate = this.addOneDay(currentDate);
    }

    return dateArray;
  },

  addOneDay(date) {
    return moment(date).add(1, 'days').toDate();
  },

  addSevenDay(date) {
    return moment(date).add(7, 'days').toDate();
  },

  getMonth(date) {
    return date.getMonth();
  }

};

var FeeDatePicker = /** @class */ (function (_super) {
    __extends(FeeDatePicker, _super);
    function FeeDatePicker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: undefined,
        };
        _this._getDefaultValue = function (defaultValue) {
            if (!defaultValue) {
                return undefined;
            }
            else if (defaultValue instanceof Date) {
                return defaultValue;
            }
            else if (typeof defaultValue === 'object') {
                return defaultValue.date;
            }
            else if (typeof defaultValue === 'string' && defaultValue.length === 8) {
                return dateUtil.getDate({ date: defaultValue, format: 'YYYYMMDD' });
            }
            else if (typeof defaultValue === 'string' && defaultValue.length === 10) {
                return dateUtil.getDate({ date: defaultValue, format: 'YYYY/MM/DD' });
            }
            else {
                throw new Error('you can only set type [object,Date,string] to defaultValue in FeeDatePicker');
                // return defaultValue;
            }
        };
        _this.handleChange = function (event) {
            var date = event.value;
            var newValue = (date) ? {
                code: moment(date).format('YYYYMMDD'),
                show: moment(date).format('YYYY/MM/DD'),
                origin: date,
                date: date
            } : {
                code: undefined,
                show: undefined,
                origin: date,
                date: date
            };
            _this.props.onChange && _this.props.onChange(event, newValue);
            // 遇到一些 limit 狀況 , 不做資料更新
            _this.setState({ value: date });
        };
        return _this;
    }
    FeeDatePicker.prototype.componentWillMount = function () {
        this.setState({
            value: this._getDefaultValue(this.props.defaultValue),
        });
    };
    FeeDatePicker.prototype.render = function () {
        var _a = this.props, defaultValue = _a.defaultValue, restProps = __rest(_a, ["defaultValue"]);
        return (React__default.createElement(kendoReactDateinputs.DatePicker, __assign({}, restProps, { width: '90%', value: this.state.value, format: "yyyy/MM/dd", onChange: this.handleChange })));
    };
    return FeeDatePicker;
}(React__default.Component));

const Style$4 = {
  datePicker: {}
};

class FeeDateTimePicker extends React__default.Component {
  constructor(...args) {
    super(...args);
    this.state = {
      value: null
    };

    this.handleChange = event => {
      // disabled 時 , 將 DatePicker 上鎖 , 不做 handleChange
      if (this.props.disabled) return;
      const date = event.value;
      const newValue = {
        code: moment(date).format('YYYYMMDD HH:mm:SS'),
        show: moment(date).format('YYYY/MM/DD HH:mm:SS'),
        origin: date
      }; // const newEvent = {target: {value: date}};

      this.props.onChange && this.props.onChange(event, newValue);
      this.setState({
        value: date
      });
    };
  }

  componentWillMount() {
    this.setState({
      value: this.props.defaultValue
    });
  }

  render() {
    return React__default.createElement(kendoReactDateinputs.DateTimePicker, _extends({}, this.props, {
      width: '90%',
      style: Style$4.datePicker,
      value: this.state.value,
      format: "yyyy/MM/dd",
      validationMessage: "\u8ACB\u8F38\u5165\u6B63\u78BA\u7684\u6642\u9593\u683C\u5F0F",
      onChange: this.handleChange
    }));
  }

}

FeeDateTimePicker.propTypes = {
  defaultValue: PropTypes.oneOfType([PropTypes.string, PropTypes.instanceOf(Date)]),
  onChange: PropTypes.func.isRequired
};

var FeeDatePickerFromAndTo = /** @class */ (function (_super) {
    __extends(FeeDatePickerFromAndTo, _super);
    function FeeDatePickerFromAndTo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            fromValue: undefined,
            toValue: undefined,
        };
        _this.getNewValueObj = function (date) {
            var newValue = (date) ? {
                code: moment(date).format('YYYYMMDD'),
                show: moment(date).format('YYYY/MM/DD'),
                origin: date,
                date: date
            } : {
                code: undefined,
                show: undefined,
                origin: date,
                date: date
            };
            return newValue;
        };
        _this.isChangeValue = function (fromValue, toValue) { return (fromValue && toValue && fromValue.getTime() > toValue.getTime()); }; // 結束日期比開始日期小
        _this.handleFromChange = function (event) {
            var fromDate = (event.value) ? event.value : undefined;
            var toValue = _this.state.toValue;
            var newToDate;
            // 跟隨開始日
            if (fromDate && _this.props.type === 'followFrom') {
                newToDate = fromDate;
            }
            else if (_this.isChangeValue(fromDate, toValue)) {
                newToDate = fromDate;
            }
            else {
                newToDate = _this.state.toValue;
            }
            _this.setState({ fromValue: fromDate, toValue: newToDate });
            var newFromValue = _this.getNewValueObj(fromDate);
            var newValues = { fromValue: newFromValue, toValue: _this.getNewValueObj(newToDate) };
            _this.props.onFromChange && _this.props.onFromChange(event, newValues);
        };
        _this.handleToChange = function (event) {
            var toDate = (event.value) ? event.value : undefined;
            var newFromDate = (_this.isChangeValue(_this.state.fromValue, toDate)) ? toDate : _this.state.fromValue;
            _this.setState({ fromValue: newFromDate, toValue: toDate });
            var newToValue = _this.getNewValueObj(toDate);
            var newValues = { fromValue: _this.getNewValueObj(newFromDate), toValue: newToValue };
            _this.props.onToChange && _this.props.onToChange(event, newValues);
        };
        return _this;
    }
    FeeDatePickerFromAndTo.prototype.componentWillMount = function () {
        this.setState({
            fromValue: this.props.defaultFrom,
            toValue: this.props.defaultTo,
        });
    };
    FeeDatePickerFromAndTo.prototype.render = function () {
        var _a = this.props, defaultFrom = _a.defaultFrom, defaultTo = _a.defaultTo, onFromChange = _a.onFromChange, onToChange = _a.onToChange, restProps = __rest(_a, ["defaultFrom", "defaultTo", "onFromChange", "onToChange"]);
        return (React__default.createElement(core.Grid, { container: true },
            React__default.createElement(core.Grid, { item: true, xs: 5 },
                React__default.createElement(kendoReactDateinputs.DatePicker, __assign({}, restProps, { width: '90%', onChange: this.handleFromChange, value: this.state.fromValue, format: "yyyy/MM/dd", validationMessage: "\u8ACB\u8F38\u5165\u6B63\u78BA\u7684\u6642\u9593\u683C\u5F0F" }))),
            React__default.createElement(core.Grid, { item: true, xs: 1, style: { textAlign: 'center' } }, "~"),
            React__default.createElement(core.Grid, { item: true, xs: 5 },
                React__default.createElement(kendoReactDateinputs.DatePicker, __assign({}, restProps, { width: '90%', onChange: this.handleToChange, value: this.state.toValue, format: "yyyy/MM/dd", validationMessage: "\u8ACB\u8F38\u5165\u6B63\u78BA\u7684\u6642\u9593\u683C\u5F0F" })))));
    };
    return FeeDatePickerFromAndTo;
}(React__default.PureComponent));

var StyledGrid = core.withStyles({})(Grid);
var StyledTitleGridBorder = core.withStyles({
    item: {
        textAlign: 'right',
        border: '1px solid #ddd',
        backgroundColor: '#efefef',
        fontWeight: "bold",
    }
})(Grid);
var StyledGridBorder = core.withStyles({
    item: {
        border: '1px solid #ddd',
    }
})(Grid);
var GridProportion = {
    xs: {
        titlecols: 4,
        contentcols: 8,
        contentlongcols: 8,
    },
    sm: {
        titlecols: 2,
        contentcols: 4,
        contentlongcols: 10,
    }
};

const cellStyles = () => ({
  high_100: {
    height: '100%'
  },
  width_100: {
    width: '100%'
  },
  from_title: {
    width: '100px'
  },
  from_value: {
    width: 'calc(100% - 100px)'
  },
  bgColorYellow: {
    backgroundColor: '#ffff02'
  },
  bgColorBlue: {
    backgroundColor: '#02ffff'
  },
  input_title: {
    paddingTop: '10px',
    paddingBottom: '5px',
    paddingRight: '3px'
  },
  input_value: {
    padding: '6px 5px'
  }
});

const formStyles = () => ({
  paddingBottom: {
    paddingBottom: '24px'
  }
});

class FormCell extends React.Component {
  constructor(...args) {
    super(...args);

    this.getCellTitleBgColor = () => {
      const {
        cellStatus
      } = this.props;
      const cellTitleBgColorMap = {
        view: undefined,
        required: '#ffff02',
        edit: '#02ffff'
      };
      return cellTitleBgColorMap[cellStatus] || '';
    };

    this.getCellValueBgColor = () => this.props.cellValueBgColor;

    this.renderWarnMsg = warnMessage => {
      return warnMessage && React.createElement("div", {
        style: {
          color: '#fdb900'
        }
      }, warnMessage);
    };

    this.renderErrMsg = errMessage => {
      return errMessage && React.createElement("div", {
        style: {
          color: 'red'
        }
      }, errMessage);
    };

    this.renderNoTitleCell = () => {
      const {
        classes,
        errMessage,
        warnMessage,
        showCellErrMsg
      } = this.props;
      return React.createElement(StyledGrid, _extends({
        item: true
      }, this.props.widthWeight, {
        className: classes.width_100
      }), React.createElement(StyledGrid, {
        container: true,
        className: classes.high_100
      }, React.createElement(StyledGridBorder, {
        item: true,
        xs: 12,
        style: {
          backgroundColor: this.getCellValueBgColor()
        }
      }, this.props.children, showCellErrMsg && (this.renderErrMsg(errMessage) || this.renderWarnMsg(warnMessage)))));
    };

    this.renderHasTitleCell = () => {
      const {
        classes,
        errMessage,
        validateMessage,
        warnMessage,
        showCellErrMsg
      } = this.props; // 參考資料 : https://stackoverflow.com/questions/46066675/how-to-add-multiple-classes-in-material-ui-using-the-classes-props
      //   className={`${this.props.classes.from_title} ${this.getCellTitleBgColor()}`}

      return React.createElement(StyledGrid, _extends({
        item: true
      }, this.props.widthWeight, {
        className: classes.width_100
      }), React.createElement(StyledGrid, {
        container: true,
        className: classes.high_100
      }, React.createElement(StyledTitleGridBorder, {
        item: true,
        className: this.props.classes.from_title,
        style: {
          backgroundColor: this.getCellTitleBgColor()
        }
      }, React.createElement("div", {
        className: this.props.classes.input_title
      }, this.props.title)), React.createElement(StyledGridBorder, {
        item: true,
        className: classes.from_value,
        style: {
          backgroundColor: this.getCellValueBgColor()
        }
      }, React.createElement("div", {
        className: this.props.classes.input_value
      }, this.props.children, showCellErrMsg && (this.renderErrMsg(errMessage) || this.renderWarnMsg(warnMessage))))));
    };
  }

  render() {
    return this.props.title ? this.renderHasTitleCell() : this.renderNoTitleCell();
  }

}

FormCell.defaultProps = {
  showCellErrMsg: false,
  widthWeight: {
    xs: 12,
    sm: 6,
    md: 2,
    lg: undefined
  }
};
const StyledFormCell = styles$1.withStyles(cellStyles)(FormCell);

const FormRow = props => React.createElement(StyledGrid, {
  container: true
}, props.children);

const FeeForm = props => React.createElement("form", {
  ref: props.onRef
}, props.title && React.createElement(Title, {
  title: props.title
}), React.createElement(FormAlertBlock, {
  alertOpen: props.alertOpen,
  alertMessage: props.alertMessage,
  fieldMapper: props.fieldMapper
}), React.createElement("div", {
  className: props.classes.paddingBottom
}, props.children));

const FeeStyledForm = styles$1.withStyles(formStyles)(FeeForm);

var WrapperForm = /** @class */ (function (_super) {
    __extends(WrapperForm, _super);
    function WrapperForm() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            singleData: {},
            editData: {},
            errMessages: {},
            warnMessages: {},
            validateMessages: {},
            formErrMsg: undefined,
        };
        _this.initData = function (_a) {
            var _b = _a.defaultData, defaultData = _b === void 0 ? {} : _b, _c = _a.errMsgChecker, errMsgChecker = _c === void 0 ? function () { return ({}); } : _c, _d = _a.warnMsgChecker, warnMsgChecker = _d === void 0 ? function () { return ({}); } : _d;
            _this.setState({
                singleData: __assign({}, defaultData),
                errMessages: __assign({}, initMessages({
                    data: defaultData,
                    messageChecker: errMsgChecker
                })),
                warnMessages: __assign({}, initMessages({
                    data: defaultData,
                    messageChecker: warnMsgChecker
                })),
                validateMessages: {},
            });
        };
        _this.updateState = function (_a) {
            var _b = _a.singleData, singleData = _b === void 0 ? {} : _b, _c = _a.warnMessage, warnMessage = _c === void 0 ? {} : _c, _d = _a.errMessage, errMessage = _d === void 0 ? {} : _d;
            _this.setState({
                singleData: __assign(__assign({}, _this.state.singleData), singleData),
                editData: __assign(__assign({}, _this.state.editData), singleData),
                warnMessages: __assign(__assign({}, _this.state.warnMessages), warnMessage),
                errMessages: __assign(__assign({}, _this.state.errMessages), errMessage)
            });
        };
        _this.handleChange = function (fieldName) { return function (event, value) {
            // errMsgChecker = undefind 時 , let errMsgChecker = () => ({}) , 回傳空物件
            var _a = _this.props, getNewData = _a.getNewData, _b = _a.errMsgChecker, errMsgChecker = _b === void 0 ? function () { return ({}); } : _b, _c = _a.warnMsgChecker, warnMsgChecker = _c === void 0 ? function () { return ({}); } : _c;
            // 先取得新 singleData
            var newSingleData = __assign(__assign({}, _this.state.singleData), getNewData({
                state: _this.state,
                singleData: _this.state.singleData,
                updateState: _this.updateState,
                fieldName: fieldName,
                value: value
            }));
            // 先取得新 editData
            var newEditData = __assign(__assign({}, _this.state.editData), getNewData({
                state: _this.state,
                singleData: newSingleData,
                updateState: _this.updateState,
                fieldName: fieldName,
                value: value
            }));
            // newErrMessages 可用新資料得出 , 不一定限制於哪欄位變更 , 才做 errMessages 的顯示
            var newErrMessages = __assign(__assign({}, _this.state.errMessages), errMsgChecker({
                singleData: newSingleData,
                updateState: _this.updateState,
                fieldName: fieldName,
                value: value
            }));
            var newWarnMessages = __assign(__assign({}, _this.state.warnMessages), warnMsgChecker({
                singleData: newSingleData,
                updateState: _this.updateState,
                fieldName: fieldName,
                value: value
            }));
            _this.setState({
                singleData: newSingleData,
                editData: newEditData,
                errMessages: newErrMessages,
                warnMessages: newWarnMessages,
                validateMessages: {},
                formErrMsg: undefined
            });
        }; };
        _this.setFormErrMsg = function (formErrMsg) { return _this.setState({ formErrMsg: formErrMsg }); };
        _this.formValidate = function () {
            if (_this.formRef && !_this.formRef.reportValidity()) {
                return false;
            }
            var validateChecker = _this.props.validateChecker;
            var formErrMsg = validateChecker && validateChecker({ singleData: _this.state.singleData });
            if (formErrMsg) {
                _this.setState({ validateMessages: _this.state.errMessages, formErrMsg: formErrMsg });
                return false;
            }
            else if (objNotEmpty(_this.state.errMessages)) {
                _this.setState({ validateMessages: _this.state.errMessages });
                return false;
            }
            else {
                // formValidate 沒問題時 , 先將 formErrMsg 設定成 undefined
                _this.setState({ formErrMsg: undefined });
                return true;
            }
        };
        _this.getFormErrMsg = function () {
            var _a = _this.state, formErrMsg = _a.formErrMsg, errMessages = _a.errMessages;
            var newErrMessages = objIsEmpty(errMessages) ? undefined : errMessages;
            return (formErrMsg && typeof formErrMsg === 'string') ? formErrMsg : newErrMessages;
        };
        _this.getEditData = function () { return (__assign(__assign({}, getDataOriginPK(_this.props.defaultData)), _this.state.editData)); };
        _this.getSingleData = function () { return _this.state.singleData; };
        _this.getQueryInfo = function () { return _this.state.singleData; };
        return _this;
    }
    WrapperForm.prototype.componentWillMount = function () {
        var _a = this.props, defaultData = _a.defaultData, errMsgChecker = _a.errMsgChecker, warnMsgChecker = _a.warnMsgChecker;
        this.initData({ defaultData: defaultData, errMsgChecker: errMsgChecker, warnMsgChecker: warnMsgChecker });
    };
    WrapperForm.prototype.render = function () {
        var _this = this;
        var _a = this.props, getFormBody = _a.getFormBody, restProps = __rest(_a, ["getFormBody"]);
        var newProps = __assign(__assign({}, restProps), { formRef: function (formRef) { return _this.formRef = formRef; } });
        return getFormBody({
            props: newProps,
            formFuncs: {
                formValidate: this.formValidate,
                setFormErrMsg: this.setFormErrMsg,
                getFormErrMsg: this.getFormErrMsg,
                getAlertMessage: this.getFormErrMsg,
                handleChange: this.handleChange,
                updateState: this.updateState,
                initData: this.initData,
            },
            formData: {
                queryInfo: this.state.singleData,
                singleData: this.state.singleData,
                editData: this.state.editData,
                warnMessages: this.state.warnMessages,
                errMessages: this.state.errMessages,
                validateMessages: this.state.validateMessages,
                formErrMsg: this.state.formErrMsg,
            }
        });
    };
    return WrapperForm;
}(React__default.Component));

const cellStatus = {
  required: 'required',
  editable: 'edit',
  disable: 'disable'
};
const componentId = {
  FEE0109Q: {
    detail_form: '[FEE0109Q]detail-form',
    detail_sub_form01: '[FEE0109Q]detail-sub-form01',
    detail_sub_form04: '[FEE0109Q]detail-sub-form04',
    detail_sub_list01: '[FEE0109Q]detail-sub-list01',
    detail_sub_list02: '[FEE0109Q]detail-sub-list02',
    detail_sub_list03: '[FEE0109Q]detail-sub-list03',
    detail_sub_list04: '[FEE0109Q]detail-sub-list04',
    main_list: '[FEE0109Q]main-list',
    query_form: '[FEE0109Q]query-form'
  },
  FEE0401M: {
    main_list: '[FEE0401M]main-list',
    detail_sub_list: '[FEE0401M]detail-sub-list',
    query_form: '[FEE0401M]query-form',
    create_form: '[FEE0401M]create-form',
    copy_form: '[FEE0401M]copy-form',
    detail_form: '[FEE0401M]detail-form',
    edit_form: '[FEE0401M]edit-form',
    edit_form01: '[FEE0401M]edit-form01',
    edit_form02: '[FEE0401M]edit-form02'
  },
  FEE0402M: {
    main_list: '[FEE0402M]main-list',
    query_form: '[FEE0402M]query-form',
    create_form: '[FEE0402M]create-form',
    detail_form: '[FEE0402M]detail-form',
    edit_form: '[FEE0402M]edit-form'
  },
  FEE0459M: {
    main_list: '[FEE0459M]main-list',
    query_form: '[FEE0459M]query-form',
    create_form: '[FEE0459M]create-form',
    detail_form: '[FEE0459M]detail-form',
    edit_form: '[FEE0459M]edit-form',
    sub_create_form: '[FEE0459M]sub-create-form',
    sub_detail_form: '[FEE0459M]sub-detail-form',
    sub_edit_form: '[FEE0459M]sub-edit-form'
  },
  FEE0750B: {
    main_list: '[FEE0750B]main-list',
    query_form: '[FEE0750B]query-form'
  },
  FEE0804M: {
    main_list: '[FEE0804M]main-list',
    query_form: '[FEE0804M]query-form',
    create_form: '[FEE0804M]create-form',
    detail_form: '[FEE0804M]detail-form',
    edit_form: '[FEE0804M]edit-form'
  },
  FEE010403M: {
    main_list: '[FEE010403M]main-list',
    query_form: '[FEE010403M]query-form',
    create_form: '[FEE010403M]create-form',
    edit_form: '[FEE010403M]edit-form',
    detail_form: '[FEE010403M]detail-form'
  },
  FEE010404M: {
    main_list: '[FEE010404M]main-list',
    query_form: '[FEE010404M]query-form',
    create_form: '[FEE010404M]create-form'
  },
  FEE010406M: {
    main_list: '[FEE010406M]main-list',
    query_form: '[FEE010406M]query-form',
    create_form: '[FEE010406M]create-form',
    edit_form: '[FEE010406M]edit-form',
    detail_form: '[FEE010406M]detail-form'
  },
  FEE010407M: {
    main_list: '[FEE010407M]main-list',
    query_form: '[FEE010407M]query-form',
    create_form: '[FEE010407M]create-form',
    edit_form: '[FEE010407M]edit-form',
    detail_form: '[FEE010407M]detail-form'
  },
  FEE010444M: {
    main_list: '[FEE010444M]main-list',
    query_form: '[FEE010444M]query-form',
    create_form: '[FEE010444M]create-form',
    edit_form: '[FEE010444M]edit-form',
    detail_form: '[FEE010444M]detail-form'
  },
  FEE010451B: {
    main_list: '[FEE010451B]main-list',
    query_form: '[FEE010451B]query-form',
    create_form: '[FEE010451B]create-form',
    edit_form: '[FEE010451B]edit-form',
    detail_form: '[FEE010451B]detail-form'
  },
  FEE010456Q: {
    main_list: '[FEE010456Q]main-list',
    query_form: '[FEE010456Q]query-form',
    detail_form: '[FEE010456Q]detail-form'
  },
  FEE010460M: {
    main_list: '[FEE010460M]main-list',
    query_form: '[FEE010460M]query-form',
    create_form: '[FEE010460M]create-form',
    edit_form: '[FEE010460M]edit-form',
    detail_form: '[FEE010460M]detail-form'
  },
  FEE010802M: {
    main_list: '[FEE010802M]main-list',
    detail_sub_list: '[FEE010802M]detail-sub-list',
    query_form: '[FEE010802M]query-form',
    detail_form: '[FEE010802M]detail-form'
  },
  FEE030736Q: {
    main_list_1: '[FEE030736Q]main-list-1',
    main_list_2: '[FEE030736Q]main-list-2',
    query_form: '[FEE030736Q]query-form'
  },
  FEE030737Q: {
    main_list_1: '[FEE030737Q]main-list-1',
    main_list_2: '[FEE030737Q]main-list-2',
    query_form: '[FEE030737Q]query-form'
  },
  FEE040420M: {
    main_list: '[FEE040420M]main-list',
    query_form: '[FEE040420M]query-form',
    create_form: '[FEE040420M]create-form',
    edit_form: '[FEE040420M]edit-form',
    detail_form: '[FEE040420M]detail-form'
  },
  FEE080302Q: {
    main_list: '[FEE080302Q]main-list',
    query_form: '[FEE080302Q]query-form',
    detail_form: '[FEE080302Q]detail-form'
  },
  FEE080411M: {
    main_list: '[FEE080411M]main-list',
    query_form: '[FEE080411M]query-form',
    create_form: '[FEE080411M]create-form',
    edit_form: '[FEE080411M]edit-form',
    detail_form: '[FEE080411M]detail-form'
  }
};
const buttonTaskId = {
  FEE0109Q: {
    searchButton: 'FEE0109Q_searchbutton',
    // 查詢
    printButton: 'FEE0109Q_printbutton',
    // 列印發票一覽表
    detailButton: 'FEE0109Q_detailbutton',
    // 顯示明細頁按鈕
    downloadButton01: 'FEE0109Q_downloadbutton01',
    // 發票主檔下載按鈕
    downloadButton02: 'FEE0109Q_downloadbutton02',
    // 收費資料下載按鈕
    downloadButton03: 'FEE0109Q_downloadbutton03',
    // 發票更改紀錄資料下載按鈕
    downloadButton04: 'FEE0109Q_downloadbutton04',
    // 發票列印資料下載按鈕
    downloadButton05: 'FEE0109Q_downloadbutton05' // 優惠發票更改紀錄資料下載按鈕

  },
  FEE0401M: {
    copyButton: 'FEE0401M_copybutton',
    calculateButton: 'FEE0401M_calculatebutton',
    downloadButton: 'FEE0401M_downloadbutton',
    detailDownloadButton: 'FEE0401M_detaildownloadbutton',
    createButton: 'FEE0401M_createbutton',
    searchButton: 'FEE0401M_searchbutton',
    detailButton: 'FEE0401M_detailbutton',
    deleteButton: 'FEE0401M_deletebutton',
    editButton: 'FEE0401M_editbutton',
    editButton01: 'FEE0401M_editbutton01',
    editButton02: 'FEE0401M_editbutton02'
  },
  FEE0459M: {
    calculateButton: 'FEE0459M_calculatebutton',
    downloadButton: 'FEE0459M_downloadbutton',
    detailDownloadButton: 'FEE0459M_detaildownloadbutton',
    createButton: 'FEE0459M_createbutton',
    searchButton: 'FEE0459M_searchbutton',
    detailButton: 'FEE0459M_detailbutton',
    deleteButton: 'FEE0459M_deletebutton',
    editButton: 'FEE0459M_editbutton'
  },
  FEE010403M: {
    downloadButton: 'FEE010403M_downloadbutton',
    searchButton: 'FEE010403M_searchbutton',
    detailButton: 'FEE010403M_detailbutton',
    editButton: 'FEE010403M_editbutton',
    createButton: 'FEE010403M_createbutton',
    deleteButton: 'FEE010403M_deletebutton'
  },
  FEE010404M: {
    downloadButton: 'FEE010403M_downloadbutton',
    searchButton: 'FEE010403M_searchbutton',
    editButton: 'FEE010403M_editbutton',
    saveButton: 'FEE010403M_savebutton'
  },
  FEE010406M: {
    downloadButton: 'FEE010406M_downloadbutton',
    searchButton: 'FEE010406M_searchbutton',
    detailButton: 'FEE010406M_detailbutton',
    editButton: 'FEE010406M_editbutton',
    createButton: 'FEE010406M_createbutton',
    deleteButton: 'FEE010406M_deletebutton'
  },
  FEE010407M: {
    downloadButton: 'FEE010407M_downloadbutton',
    searchButton: 'FEE010407M_searchbutton',
    detailButton: 'FEE010407M_detailbutton',
    editButton: 'FEE010407M_editbutton',
    createButton: 'FEE010407M_createbutton',
    deleteButton: 'FEE010407M_deletebutton'
  },
  FEE010444M: {
    downloadButton: 'FEE010444M_downloadbutton',
    searchButton: 'FEE010444M_searchbutton',
    detailButton: 'FEE010444M_detailbutton',
    editButton: 'FEE010444M_editbutton',
    createButton: 'FEE010444M_createbutton',
    deleteButton: 'FEE010444M_deletebutton'
  },
  FEE010451B: {
    downloadButton: 'FEE010451B_downloadbutton',
    searchButton: 'FEE010451B_searchbutton',
    detailButton: 'FEE010451B_detailbutton',
    editButton: 'FEE010451B_editbutton',
    createButton: 'FEE010451B_createbutton',
    deleteButton: 'FEE010451B_deletebutton'
  },
  FEE010456Q: {
    downloadButton: 'FEE010456Q_downloadbutton',
    searchButton: 'FEE010456Q_searchbutton',
    detailButton: 'FEE010456Q_detailbutton'
  },
  FEE010460M: {
    downloadButton: 'FEE010460M_downloadbutton',
    searchButton: 'FEE010460M_searchbutton',
    detailButton: 'FEE010460M_detailbutton',
    saveButton: 'FEE010460M_savebutton'
  },
  FEE010802M: {
    downloadButton: 'FEE010802M_downloadbutton',
    searchButton: 'FEE010802M_searchbutton',
    detailButton: 'FEE010802M_detailbutton',
    popupCancelViewButton: 'FEE010802M_popupcancelviewbutton',
    cancelButton: 'FEE010802M_cancelbutton',
    releaseMediaButton: 'FEE010802M_releasemediabutton',
    releaseAccountButton: 'FEE010802M_releaseaccountbutton'
  },
  FEE030736Q: {
    downloadButton01: 'FEE030736Q_downloadbutton01',
    downloadButton02: 'FEE030736Q_downloadbutton02',
    searchButton: 'FEE030736Q_searchbutton'
  },
  FEE030737Q: {
    downloadButton01: 'FEE030737Q_downloadbutton01',
    downloadButton02: 'FEE030737Q_downloadbutton02',
    searchButton: 'FEE030737Q_searchbutton'
  },
  FEE030749Q: {
    downloadButton01: 'FEE030749Q_downloadbutton01',
    downloadButton02: 'FEE030749Q_downloadbutton02',
    downloadButton03: 'FEE030749Q_downloadbutton03',
    downloadButton04: 'FEE030749Q_downloadbutton04',
    searchButton: 'FEE030749Q_searchbutton'
  },
  FEE040420M: {
    downloadButton: 'FEE040420M_downloadbutton',
    searchButton: 'FEE040420M_searchbutton',
    detailButton: 'FEE040420M_detailbutton',
    editButton: 'FEE040420M_editbutton',
    createButton: 'FEE040420M_createbutton',
    deleteButton: 'FEE040420M_deletebutton'
  },
  FEE080302Q: {
    downloadButton: 'FEE080302Q_downloadbutton',
    searchButton: 'FEE080302Q_searchbutton',
    detailButton: 'FEE080302Q_detailbutton',
    printButton: 'FEE080302Q_printbutton' // 列印統計報表

  },
  FEE080411M: {
    downloadButton: 'FEE080411M_downloadbutton',
    searchButton: 'FEE080411M_searchbutton',
    detailButton: 'FEE080411M_detailbutton',
    editButton: 'FEE080411M_editbutton',
    createButton: 'FEE080411M_createbutton',
    deleteButton: 'FEE080411M_deletebutton'
  },
  FEE0804M: {
    downloadButton: 'FEE0804M_downloadbutton',
    createButton: 'FEE0804M_createbutton',
    searchButton: 'FEE0804M_searchbutton',
    detailButton: 'FEE0804M_detailbutton',
    deleteButton: 'FEE0804M_deletebutton',
    editButton: 'FEE0804M_editbutton'
  },
  FEE0750B: {
    printButton: 'FEE0750B_printbutton',
    showSendListButton: 'FEE0750B_showsendlistbutton',
    sendButton: 'FEE0750B_sendbutton',
    downloadButton: 'FEE0750B_downloadbutton'
  }
};
const viewMode = {
  FEE0109Q: {
    detail: 'detail',
    query: 'query',
    list: 'list'
  },
  FEE0401M: {
    detail: 'detail',
    copy: 'copy',
    create: 'create',
    edit: 'edit',
    edit_1: 'edit_1',
    edit_2: 'edit_2',
    list: 'list'
  },
  FEE0402M: {
    detail: 'detail',
    create: 'create',
    edit: 'edit',
    list: 'list'
  },
  FEE0459M: {
    detail: 'detail',
    edit: 'edit',
    list: 'list',
    query: 'query',
    sub_detail: 'sub_detail',
    sub_create: 'sub_create',
    sub_edit: 'sub_edit',
    sub_delete: 'sub_delete'
  },
  FEE0804M: {
    detail: 'detail',
    create: 'create',
    edit: 'edit',
    query: 'query'
  },
  FEE010403M: {
    detail: 'detail',
    create: 'create',
    edit: 'edit',
    query: 'query'
  },
  FEE010406M: {
    detail: 'detail',
    create: 'create',
    edit: 'edit',
    query: 'query'
  },
  FEE010407M: {
    detail: 'detail',
    create: 'create',
    edit: 'edit',
    query: 'query'
  },
  FEE010444M: {
    detail: 'detail',
    create: 'create',
    edit: 'edit',
    query: 'query'
  },
  FEE010451B: {
    detail: 'detail',
    create: 'create',
    edit: 'edit',
    query: 'query'
  },
  FEE010456Q: {
    detail: 'detail',
    create: 'create',
    edit: 'edit',
    query: 'query'
  },
  FEE010802M: {
    detail: 'detail',
    query: 'query'
  },
  FEE030736Q: {
    detail: 'detail',
    query: 'query'
  },
  FEE040420M: {
    detail: 'detail',
    create: 'create',
    edit: 'edit',
    query: 'query'
  },
  FEE080302Q: {
    detail: 'detail',
    query: 'query'
  },
  FEE080411M: {
    detail: 'detail',
    create: 'create',
    edit: 'edit',
    query: 'query'
  }
};
const feeProperty = {
  cellStatus,
  buttonTaskId,
  componentId,
  viewMode
};

// 貨棧別
const cargoLocationOptions = [{
  show: '台北',
  code: 'C'
}, {
  show: '高雄',
  code: 'K'
}]; // 貨棧別

const cargoLocationWithAllOptions = [...cargoLocationOptions, {
  show: '全部',
  code: 'A'
}]; // 保證類別 : 定期存單	1/銀行保證	2/質押票據	3/現金	4/連帶保證	5/

const creditTypeOptions = [{
  code: '1',
  show: '定期存單'
}, {
  code: '2',
  show: '銀行保證'
}, {
  code: '3',
  show: '質押票據'
}, {
  code: '4',
  show: '現金'
}, {
  code: '5',
  show: '連帶保證'
}]; // GCO 狀態 : 已出倉	Y/未出倉	N/

const gcoStatusOptions = [{
  code: 'Y',
  show: '已出倉'
}, {
  code: 'N',
  show: '未出倉'
}]; // 特殊品 : 一般	 /貴重品~	V/冷藏品~	C/冷凍品~	Z/危險品~	R/冷藏+危險	D/冷凍+危險	Y/木墊區	W/整盤整櫃	F/

const goodsMeasureSpecialFlagOptions = [{
  code: '',
  show: '一般'
}, {
  code: 'V',
  show: '貴重品'
}, {
  code: 'C',
  show: '冷藏品'
}, {
  code: 'Z',
  show: '冷凍品'
}, {
  code: 'R',
  show: '危險品'
}, {
  code: 'D',
  show: '冷藏+危險'
}, {
  code: 'Y',
  show: '冷凍+危險'
}, {
  code: 'W',
  show: '木墊區'
}, {
  code: 'F',
  show: '整盤整櫃'
}]; // 倉別 : 出口	E/轉口	T/無GCI	N/全部	%/

const locaTypeOptions = [{
  code: 'E',
  show: '出口'
}, {
  code: 'T',
  show: '轉口'
}, {
  code: 'N',
  show: '無GCI'
}, {
  code: '%',
  show: '全部'
}]; // 特殊通關類型 : 一般	/一段式	E/海空聯運	S/三角貿易	*/保稅	P/押運	1/外~貨轉口(空陸空)	O/

const goodsInHouseSpecialFlagOptions = [{
  code: '',
  show: '一般'
}, {
  code: 'V',
  show: '貴重品'
}, {
  code: 'E',
  show: '一段式'
}, {
  code: 'S',
  show: '海空聯運'
}, {
  code: '*',
  show: '三角貿易'
}, {
  code: 'P',
  show: '保稅'
}, {
  code: '1',
  show: '押運'
}, {
  code: 'O',
  show: '外貨轉口(空陸空)'
}, {
  code: 'Z',
  show: '冷藏品'
}, {
  code: 'R',
  show: '危險品'
}, {
  code: 'D',
  show: '冷藏+危險'
}, {
  code: 'Y',
  show: '冷凍+危險'
}, {
  code: 'W',
  show: '木墊區'
}, {
  code: 'F',
  show: '整盤整櫃'
}]; // 優惠金額選擇Add20170601

const preferOptionOptions = [{
  code: 'A',
  show: '調整後'
}, {
  code: 'B',
  show: '原優惠'
}]; // 收費項目

const chargeKindOptions = [{
  code: 'E',
  show: '出口倉租'
}, {
  code: 'I',
  show: '進口倉租'
}, {
  code: 'T',
  show: '轉口倉租'
}, {
  code: 'OT',
  show: '雜項'
}, {
  code: 'TT',
  show: '轉口優惠'
}, {
  code: 'UP',
  show: '空盤費'
}, {
  code: 'UC',
  show: '空櫃費'
}, {
  code: 'SP',
  show: '短溢收倉租'
}, {
  code: 'SQ',
  show: '短溢收雜項'
}, {
  code: 'TD',
  show: '轉口拆盤'
}, {
  code: 'TB',
  show: '轉口裝盤'
}, {
  code: 'P',
  show: '機出倉租'
}, {
  code: 'X',
  show: '機進倉租'
}, {
  code: 'O',
  show: 'OBC倉租'
}, {
  code: 'RB',
  show: '出口再裝'
}, {
  code: 'OTA',
  show: '空轉空-雜項'
}, {
  code: 'RBA',
  show: '空轉空-出口再裝'
}, {
  code: 'TDA',
  show: '空轉空-轉口拆盤'
}, {
  code: 'TA',
  show: '空轉空-轉口倉租'
}, {
  code: 'ID',
  show: '進口拆盤'
}, {
  code: 'EX',
  show: 'EHU倉租'
}]; // 收款方式

const paymentTypeFee0401mOptions = [{
  code: 'C',
  show: '現金'
}, {
  code: 'N',
  show: '週結現開'
}, {
  code: 'W',
  show: '週結週開'
}, {
  code: 'H',
  show: '半月結'
}, {
  code: 'M',
  show: '月結'
}, {
  code: 'K',
  show: '半月現開'
}, {
  code: 'L',
  show: '月結現開'
}]; // 收款方式

const paymentTypeFee0444mOptions = [{
  code: 'W',
  show: '週'
}, {
  code: 'H',
  show: '半月'
}, {
  code: 'M',
  show: '月'
}]; // 收款方式

const paymentType01Options = [{
  code: 'W',
  show: '週結週開'
}, {
  code: 'N',
  show: '週結現開'
}, {
  code: 'H',
  show: '半月結'
}, {
  code: 'M',
  show: '月結'
}, {
  code: 'F',
  show: '免費'
}, {
  code: 'C',
  show: '現金'
}]; // 收款方式

const paymentTypeFee0456qOptions = [{
  code: 'W',
  show: '週結'
}, {
  code: 'N',
  show: '週現'
}, {
  code: 'H',
  show: '半月結'
}, {
  code: 'K',
  show: '半月現'
}, {
  code: 'M',
  show: '月結'
}, {
  code: 'L',
  show: '月現'
}]; // 收款方式

const paymentTypeFee0109qOptions = [{
  code: 'C',
  show: '現金'
}, {
  code: 'W',
  show: '週結週開'
}, {
  code: 'N',
  show: '週結現開'
}, {
  code: 'H',
  show: '半月結'
}, {
  code: 'K',
  show: '半月現開'
}, {
  code: 'M',
  show: '月結'
}, {
  code: 'L',
  show: '月結現開'
}, {
  code: 'A',
  show: '全部'
}]; // 收款方式

const paymentType02Options = [{
  code: 'W',
  show: '週結'
}, {
  code: 'N',
  show: '週現'
}, {
  code: 'H',
  show: '半月結'
}, {
  code: 'M',
  show: '月結'
}, {
  code: 'K',
  show: '半月現'
}, {
  code: 'L',
  show: '月現'
}, {
  code: '1',
  show: '現開'
}, {
  code: '2',
  show: '記帳'
}, {
  code: 'A',
  show: '全部'
}]; // 收款方式

const paymentType03Options = [{
  code: 'W',
  show: '週結週開'
}, {
  code: 'N',
  show: '週結現開'
}, {
  code: 'H',
  show: '半月結'
}, {
  code: 'M',
  show: '月結'
}, {
  code: 'K',
  show: '半月結現開'
}, {
  code: 'L',
  show: '月結現開'
}, {
  code: 'C',
  show: '現金'
}, {
  code: 'A',
  show: '全部'
}]; // 收款方式

const paymentTypeTotalOptions = [{
  code: 'W',
  show: '週結週開'
}, {
  code: 'N',
  show: '週結現開'
}, {
  code: 'H',
  show: '半月結'
}, {
  code: 'M',
  show: '月結'
}, {
  code: 'K',
  show: '半月結現開'
}, {
  code: 'L',
  show: '月結現開'
}, {
  code: 'F',
  show: '免費'
}, {
  code: 'C',
  show: '現金'
}, {
  code: '1',
  show: '現開'
}, {
  code: '2',
  show: '記帳'
}, {
  code: 'A',
  show: '全部'
}]; // 現金/記帳

const payAttrOptions = [{
  code: 'C',
  show: '現金'
}, {
  code: 'B',
  show: '記帳'
}, {
  code: 'A',
  show: '不分'
}]; // 借/貸方

const crDbOptions = [{
  code: 'CR',
  show: '貸方'
}, {
  code: 'DR',
  show: '借方'
}]; // 是否已註銷

const deleteMarkOptions = [{
  code: 'Y',
  show: '註銷'
}, {
  code: 'N',
  show: '正常'
}]; // 是否已註銷

const deleteMarkWithAllOptions = [...deleteMarkOptions, {
  code: '0',
  show: '不分'
}]; // 客戶類型

const customerTypeOptions = [{
  code: 'E',
  show: '承攬業者'
}, {
  code: 'I',
  show: '報關箱號'
}]; // 客戶類型

const customerType02Options = [{
  code: 'A',
  show: '航空公司'
}, {
  code: '/',
  show: '承攬業者'
}, {
  code: 'F',
  show: '報關箱號'
}, {
  code: 'I',
  show: '客戶統編'
}, {
  code: 'C',
  show: '記帳客戶'
}, {
  code: '0',
  show: '全部'
}]; // 要印帳單

const billPrintOptions = [{
  code: 'Y',
  show: '要印帳單'
}, {
  code: 'N',
  show: '不印帳單'
}, {
  code: 'A',
  show: '不分'
}]; // 客戶性質

const custAttributeOptions = [{
  code: 'N',
  show: '一般'
}, {
  code: 'F',
  show: '免費'
}, {
  code: 'A',
  show: '航空公司'
}, {
  code: 'B',
  show: '快遞客戶'
}, {
  code: '0',
  show: '全部'
}]; // 列印日報

const dailyReportOptions = [{
  code: 'A',
  show: '全部'
}, {
  code: 'N',
  show: '不印'
}, {
  code: 'Y',
  show: '印'
}]; // 客戶額度

const notEnoughOptions = [{
  code: '1',
  show: '不足'
}, {
  code: '2',
  show: '不限'
}, {
  code: '3',
  show: '低於'
}]; // 額度警示

const warningFlagOptions = [{
  code: 'Y',
  show: '有'
}, {
  code: 'N',
  show: '無'
}, {
  code: 'A',
  show: '不分'
}]; // 額度警示

const invTaxAdjustOptions = [{
  code: 'Y',
  show: '可調'
}, {
  code: 'N',
  show: '不可'
}, {
  code: 'A',
  show: '所有'
}]; // 是 / 否

const yesNoOptions = [{
  code: 'Y',
  show: '是'
}, {
  code: 'N',
  show: '否'
}]; // FEE0459M flag

const flagOptions = [{
  code: 'Y',
  show: '正常'
}, {
  code: 'N',
  show: '終止'
}]; // 貨別 : 一般	N/OFLD	2/直轉	Y/押運	1/外~倉	3/公司貨	4/出(未進)	5/轉(未進)	6/機出	P/高倉轉	K/空陸空	O/

const goFlagOptions = [{
  code: 'N',
  show: '一般'
}, {
  code: '2',
  show: 'OFLD'
}, {
  code: 'Y',
  show: '直轉'
}, {
  code: '1',
  show: '押運'
}, {
  code: '3',
  show: '外倉'
}, {
  code: '4',
  show: '公司貨'
}, {
  code: '5',
  show: '出(未進)'
}, {
  code: '6',
  show: '轉(未進)'
}, {
  code: 'P',
  show: '機出'
}, {
  code: 'K',
  show: '高倉轉'
}, {
  code: 'O',
  show: '空陸空'
}]; // 是 / 否

const yesNoWithAllOptions = [...yesNoOptions, {
  code: 'A',
  show: '所有'
}]; // 發票品名代碼

const invDescOptions = [{
  code: '0',
  show: '全部'
}, {
  code: 'H',
  show: '航空公司倉儲費、倉庫使用費'
}, {
  code: 'D',
  show: '延遲倉租費'
}, {
  code: 'G',
  show: '航空公司空轉空倉儲費'
}, {
  code: 'S',
  show: '進口貨物海關拍賣費'
}, {
  code: 'U',
  show: 'EHU倉租費'
}, {
  code: 'A',
  show: '承攬業者倉儲費'
}, {
  code: 'C',
  show: 'SBP補倉租'
}, {
  code: '1',
  show: '週結倉租費'
}, {
  code: '2',
  show: '半月結倉租費'
}, {
  code: '3',
  show: '月結倉租費'
}, {
  code: '4',
  show: '裝盤費'
}, {
  code: '5',
  show: '空盤櫃保管費'
}, {
  code: '6',
  show: '裝備費用'
}, {
  code: '7',
  show: 'EHU暫繳現金'
}, {
  code: '8',
  show: '快遞出口暫繳現金'
}, {
  code: 'O',
  show: '快遞出口倉租費'
}, {
  code: 'B',
  show: 'EHU+快遞出口暫繳現金'
}, {
  code: '9',
  show: '堆高機使用費'
}]; // 計費狀態 : 全部	A/已計費	Y/未計費	N/

const feeStatusOptions = [{
  code: 'N',
  show: '未計費'
}, {
  code: 'Y',
  show: '已計費'
}, {
  code: 'A',
  show: '全部'
}]; // 發票狀態

const invoiceMasterStatusOptions = [{
  code: 'L',
  show: '申報'
}, {
  code: 'C',
  show: '作廢'
}, {
  code: 'N',
  show: '一般'
}, {
  code: 'A',
  show: '全部'
}]; // 稅別

const taxMarkOptions = [{
  code: '1',
  show: '應稅'
}, {
  code: '2',
  show: '零稅率'
}, {
  code: '3',
  show: '免稅'
}, {
  code: 'A',
  show: '全部'
}]; // 倉別

const workTypeOptions = [{
  code: 'I',
  show: '進口'
}, {
  code: 'E',
  show: '出口'
}, {
  code: 'T',
  show: '轉口'
}, {
  code: 'X',
  show: '機放進口'
}, {
  code: 'P',
  show: '機放出口'
}, {
  code: 'O',
  show: '快遞出口'
}]; // 發票字軌狀態

const invoiceNoStatusOptions = [{
  code: 'N',
  show: '未用完'
}, {
  code: 'Y',
  show: '用完'
}]; // 發票聯式

const invoiceTypeOptions = [{
  code: '31',
  show: '三聯'
}, {
  code: '32',
  show: '二聯'
}]; // 收費資料狀態

const chargeSpStatusOptions = [{
  code: '0',
  show: '未計費'
}, {
  code: '1',
  show: '已計費'
}, {
  code: '2',
  show: '已開發票'
}, {
  code: '3',
  show: '已作廢'
}, {
  code: '4',
  show: '改標作廢'
}]; // 優惠發票更改抬頭狀態

const preferInvChgStatusOptions = [{
  code: '1',
  show: '已計費'
}, {
  code: '2',
  show: '已開發票'
}, {
  code: '3',
  show: '已作廢'
}]; // 優惠方案

const preferFlagOptions = [{
  code: 'F',
  show: '班機'
}, {
  code: 'N',
  show: '無'
}, {
  code: 'P',
  show: '合併分批'
}, {
  code: 'Y',
  show: '個案'
}, {
  code: '1',
  show: '1'
}, {
  code: '2',
  show: '2'
}, {
  code: '3',
  show: '3'
}, {
  code: '4',
  show: '4'
}, {
  code: '5',
  show: '5'
}, {
  code: '6',
  show: '6'
}]; // 優退方式

const returnTypeOptions = [{
  code: '1',
  show: '線上'
}, {
  code: '2',
  show: '後退'
}, {
  code: null,
  show: '無'
}]; // 實質保證金狀態 : 無效	N/有效	Y/

const validOptions = [{
  code: 'N',
  show: '無效'
}, {
  code: 'Y',
  show: '有效'
}]; // 收入類型

const storageMarkOptions = [{
  code: 'Y',
  show: '倉租'
}, {
  code: 'N',
  show: '雜項'
}, {
  code: 'A',
  show: '全部'
}]; // 繳款期限 : 0.通則	0/1.次月	1/2.次次月	2/3.天數增加	3/4.期數(一期半個月)	4/

const periodOptions = [{
  code: '0',
  show: '0.通則'
}, {
  code: '1',
  show: '1.次月'
}, {
  code: '2',
  show: '2.次次月'
}, {
  code: '3',
  show: '3.天數增加'
}, {
  code: '4',
  show: '4.期數(一期半個月)'
}];
const feeOptions = {
  billPrintOptions,
  cargoLocationOptions,
  cargoLocationWithAllOptions,
  chargeKindOptions,
  chargeSpStatusOptions,
  crDbOptions,
  creditTypeOptions,
  custAttributeOptions,
  customerType02Options,
  customerTypeOptions,
  dailyReportOptions,
  deleteMarkOptions,
  deleteMarkWithAllOptions,
  flagOptions,
  gcoStatusOptions,
  invDescOptions,
  invoiceMasterStatusOptions,
  invoiceNoStatusOptions,
  invoiceTypeOptions,
  invTaxAdjustOptions,
  notEnoughOptions,
  payAttrOptions,
  paymentType01Options,
  paymentType02Options,
  paymentType03Options,
  paymentTypeFee0109qOptions,
  paymentTypeFee0401mOptions,
  paymentTypeFee0444mOptions,
  paymentTypeFee0456qOptions,
  paymentTypeTotalOptions,
  periodOptions,
  locaTypeOptions,
  preferFlagOptions,
  goFlagOptions,
  preferInvChgStatusOptions,
  preferOptionOptions,
  returnTypeOptions,
  goodsInHouseSpecialFlagOptions,
  goodsMeasureSpecialFlagOptions,
  storageMarkOptions,
  feeStatusOptions,
  taxMarkOptions,
  validOptions,
  warningFlagOptions,
  workTypeOptions,
  yesNoOptions,
  yesNoWithAllOptions
};

exports.CommentFont = CommentFont;
exports.FeeCheckbox = FeeCheckbox;
exports.FeeDatePicker = FeeDatePicker;
exports.FeeDatePickerFromAndTo = FeeDatePickerFromAndTo;
exports.FeeDateTimePicker = FeeDateTimePicker;
exports.FeeDeleteConfirm = FeeDeleteConfirm;
exports.FeeDialog = FeeDialog$1;
exports.FeeInput = FeeInput$1;
exports.FeeRadioGroup = FeeRadioGroup;
exports.FeeStyledForm = FeeStyledForm;
exports.FeeTab = FeeTab;
exports.FeeTaskbar = FeeTaskbar;
exports.FilterableComboBox = FilterableComboBox;
exports.FormAlertBlock = FormAlertBlock;
exports.FormRow = FormRow;
exports.GridProportion = GridProportion;
exports.StyledAreaFuctionButton = StyledAreaFuctionButton;
exports.StyledButtonCancel = StyledButtonCancel;
exports.StyledButtonConfirm = StyledButtonConfirm;
exports.StyledFormCell = StyledFormCell;
exports.StyledGrid = StyledGrid;
exports.StyledGridBorder = StyledGridBorder;
exports.StyledTitleGridBorder = StyledTitleGridBorder;
exports.Title = Title;
exports.WordWrapP = WordWrapP;
exports.WrapperForm = WrapperForm;
exports.baseGetNewData = baseGetNewData;
exports.dateUtil = dateUtil;
exports.feeOptions = feeOptions;
exports.feeProperty = feeProperty;
exports.getByteCount = getByteCount;
exports.getCodeFieldName = getCodeFieldName;
exports.getDataOriginPK = getDataOriginPK;
exports.getDebounceFunc = getDebounceFunc;
exports.getMessages = getMessages;
exports.getNumberArray = getNumberArray;
exports.getOptionObj = getOptionObj;
exports.getValidationMessage = getValidationMessage;
exports.getWarnDataMsg = getWarnDataMsg;
exports.initMessages = initMessages;
exports.isChineseChar = isChineseChar;
exports.leftStr = leftStr;
exports.numberUtil = numberUtil;
exports.objIsEmpty = objIsEmpty;
exports.objNotEmpty = objNotEmpty;
exports.retrieveFormErrMsg = retrieveFormErrMsg;
exports.rightStr = rightStr;
exports.smoothScrollTo = smoothScrollTo;
